# webgl-workshop

[![NPM](https://nodei.co/npm/webgl-workshop.png?downloads=true&stars=true)](https://nodei.co/npm/webgl-workshop/)

**Learn the basics of WebGL in small, manageable chunks. The sequel to
[shader-school](http://github.com/stackgl/shader-school), created for
[CampJS IV](http://campjs.com/) by
[Mikola Lysenko](http://github.com/mikolalysenko) and
[Hugh Kennedy](http://github.com/hughsk).**

## Running This Thing

First, you need to [get a browser with WebGL](http://get.webgl.org/), as well
as a copy of [node.js](http://nodejs.org/) and [git](http://git-scm.com/). Once you have
all of that set up, you can install the workshop using [npm](http://npmjs.org/), which
is included with node:

After that completes, you should be able to run the workshopper with the command:

``` bash
webgl-workshop
```

The script will ask you if you want to create an answer directory, press `y` to
accept. This will populate your current directory with shader files for you to
edit for each lesson.

## Other Resources

There are also local copies of the following documentation available in the
[docs](docs/) directory in this repository.

* [WebGL Quick Reference Card](https://www.khronos.org/files/webgl/webgl-reference-card-1_0.pdf)

## Stuck?

Feedback and criticism is welcome, please log your troubles in
[issues](https://github.com/stackgl/webgl-workshop/issues).

Full curriculum reviews
[like this one](https://github.com/timoxley/functional-javascript-workshop/issues/7)
are very helpful. More feedback like this please!

## Screenshots

![screenshot](http://i.imgur.com/Bd6c9LL.png)

![screenshot](http://i.imgur.com/FJLt56E.jpg)

![screenshot](http://i.imgur.com/oIsbh9D.jpg)

![screenshot](http://i.imgur.com/9tt3GSv.png)

## License

MIT. See
[LICENSE.md](https://github.com/stackgl/webgl-workshop/blob/master/LICENSE.md)
for more details.

Many thanks to [Raph Levien](http://en.wikipedia.org/wiki/Inconsolata) for
designing [Inconsolata](http://levien.com/type/myfonts/inconsolata.html) which
is used in this project, and licensed under the
[SIL Open Font License](http://scripts.sil.org/cms/scripts/page.php?site_id=nrsi&id=OFL).
